.include "m8535def.inc"
;******** *********
.equ p_dat = PC1
.equ p_clk = PC0
.equ p_CS = PC2
.equ RamStart = 0x60

.def Data = r18
.def tmp = r16
.def tmp1 = r22
.def loop = r17
.def Cnt = r19
.def Val = R20

.org 0x00
rjmp Reset
.org 0x01
rjmp Ext_Int_0
.org 0x02
rjmp Ext_Int_1
.org 0x03
rjmp Timer2_Compare
.org 0x04
rjmp Timer2_Overflow
.org 0x05
rjmp Timer1_Capture
.org 0x06
rjmp Timer1_Compare_A
.org 0x07
rjmp Timer1_Compare_B
.org 0x08
rjmp Timer1_Overflow
.org 0x09
rjmp Timer0_Overflow
.org 0x0a
rjmp Serial_Transfer_Compl
.org 0x0b
rjmp USART_RX_Compl
.org 0x0c
rjmp USART_Data_Reg_Empty
.org 0x0d
rjmp USART_TX_Compl
.org 0x0e
rjmp ADC_Conv_Copml
.org 0x0f
rjmp EE_RDY
.org 0x10
rjmp Analog_Comp
.org 0x11
rjmp TwoWrite_Ser_Interf
.org 0x12
rjmp Ext_Int_2
.org 0x13
rjmp Timer0_Compare
.org 0x14
rjmp StoreProgMem_RDY
;****************************************
;******* ********
;!!!!!!:    
;	    Reset!!!!!!!!!!!
Ext_Int_0:
Ext_Int_1:
Timer2_Compare:
Timer2_Overflow:
Timer1_Capture:
Timer1_Compare_A:
Timer1_Compare_b:
Timer1_Overflow:
Timer0_Overflow:
Serial_Transfer_Compl:
USART_RX_Compl:
USART_Data_Reg_Empty:
USART_TX_Compl:
ADC_Conv_Copml:
EE_RDY:
Analog_Comp:
TwoWrite_Ser_Interf:
Ext_Int_2:
Timer0_Compare:
StoreProgMem_RDY:
;****************************************
;*******  ********
.org 0x15
Reset:
;**********  !!!***************
	ldi	r16,low(RAMEND)
	out	SPL,r16
	ldi	r16,high(RAMEND)
	out	SPH,r16
;*****************************************************
SER tmp
OUT DDRC, tmp
OUT DDRD, tmp
CLR tmp
OUT PORTC, tmp
OUT PORTD, tmp
CLR data
RJMP Main

p_Init:

ldi    tmp,0xE2       //  
rcall  p_cmd         // Internal reset
W:
dec R0
BRNE W 
;ldi    tmp,0xDA        // 
;rcall  p_cmd         //  ID2(?)
;ldi    tmp,0xFE        // 
;rcall  p_cm          //  ??? No CMD (READ ID2?)
;ldi    tmp,0xD8        // OTP << 0 ???? FUCK!
;rcall  p_cmd         //  No such CMD in datasheet
;ldi    tmp,0x80        // 
;rcall  p_cm          //  Read? Write? o_O
;ldi    tmp,0xDC        //  
;rcall  p_cmd         // ID3 WTF???
;ldi    tmp,0x0D        // 
;rcall  p_cm          // Why it?
;ldi    tmp,0xAB        // 
;rcall  p_cmd         //  Vertical addressing (0xAA = Horisontal)
;ldi    tmp,0x13        //  
;rcall  p_cmd         // SetX = 0110000 (48). Why???

;ldi    tmp,0xA9         // 
;rcall  p_cmd         	// DataOrientation - MSB - UP (0xA8 - MSB - Dn)
//     =\
;ldi    tmp,0xA1        //  
;rcall  p_cmd         // Special CMD - MirrorX
ldi    tmp,0b10101011       //  
rcall  p_cmd         //   -  . ?
ldi    tmp,0x88       //  
rcall  p_cmd         // 0x80.....9F Contrast 
ldi    tmp,0xA4        // 
rcall  p_cmd         // Normal Display (0xA4|All ON 0xA5)
ldi    tmp,0x2F        // 
rcall  p_cmd         // 0x2C/0x28 - PumpON/OFF
;ldi    tmp,0xC0        // 
;rcall  p_cmd         // UnmirroredY (0xC0 - UnMirror/ 0xC8 - Mirror)
;ldi    tmp,0xA6        // 
;rcall  p_cmd         //  Normal Display (Inverce 0xA7)
;ldi    tmp,0x40        // 
;rcall  p_cmd         //  Start at 0 ROW (0x40 - 0x5F)  
ldi    tmp,0xAF        // 
rcall  p_cmd         //  Display ON (0xAE|0xAE - OFF)
ret                     // 
                     // 



p_cmd:               // Send command to LCD
cbi    PORTC,p_CS    // select chip  

cbi    PORTC,p_dat
sbi    PORTC,p_clk   // CLK -> 1 
nop                    // 
nop                    // 
cbi     PORTC,p_clk  // CLK -> 0 
p_cm:
ldi     loop,8         // 
outs11:                //   
clc                    // 
rol     tmp            // 
brcc    noc1           // 
sbi     PORTC,p_dat  // DATA=1
rjmp    drdy1          // 
noc1:                  // 
cbi     PORTC,p_dat  // DATA=0
drdy1:                 //  
nop                    // 
sbi     PORTC,p_clk  // CLK -> 1 
nop                    // 
nop                    // 
cbi     PORTC,p_clk  // CLK -> 0 
dec     loop           // 
brne    outs11         //  
sbi    PORTC,p_CS    // select chip  
clc
ret                    // 

out_byte:              // Send data to LCD
mov		tmp, Data
cbi    PORTC,p_CS    // select chip  

sbi    PORTC,p_dat
sbi    PORTC,p_clk   // CLK -> 1 
nop                    // 
nop                    // 
cbi     PORTC,p_clk  // CLK -> 0 
ldi     loop,8 
RJMP OUTS11; Subs are Identical.


MAIN:
RCALL p_init

Rcall Prep
RJMP STOP

rjmp s_prog

S_Prog:
;LPM data, Z+
INC data
Rcall out_byte
Inc R0
BRNE S_Prog

STOP:

CLR tmp
out portd, tmp

SBI PORTD, 7
ldi r16,0b01010000;	     Sleep
out mcucr,r16;	 Sleep Enable  ADC Noice Reduction
Sleep
RJMP STOP

PREP:
LDI Zl, Low(RamStart)
LDI Zh, High(RamStart)
LDI Data, 64
Prep_L:
DEC Data
ST Z+, Data
CPI Zl, RamStart + 96
BRNE Prep_L
RCALL Rendero_O
Ret

WriteMEM:
LDI Zl, Low(RamStart)
LDI Zh, High(RamStart)
WrLoop_1:
CPi Zl, RamStart + 96 ; 95 ?
BRLO WrCont ;  95  - 
RET	; . - 

WrCont:
LD tmp, Z+ ;   
CP tmp, Val ;   
BRSH WrLoop_2 ;       -.
LDI Data, 0
Rcall Out_Byte ;   .
RJMP WrLoop_1

WrLoop_2:
LDI Data, 0x80 ;  
WrLoop_3:
CP tmp, Val
BREQ WrSend ;   - .
LSR Data
DEC Tmp
RJMP WrLoop_3

WrSend:
RCall out_byte
rjmp WrLoop_1




Rendero_O:
LDI Val, 56
RCALL WriteMEM
LDI Val, 48
RCALL WriteMEM
LDI Val, 40
RCALL WriteMEM
LDI Val, 32
RCALL WriteMEM
LDI Val, 24
RCALL WriteMEM
LDI Val, 16
RCALL WriteMEM
LDI Val, 8
RCALL WriteMEM
LDI Val, 0
RCALL WriteMEM
RET













